# SoTranslate2Dragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoTranslate2Dragger.h>`

Inheritance diagram for SoTranslate2Dragger:

List of all members.

## Detailed Description

The SoTranslate2Dragger class provides a mechanism for the end-user to translate in a plane.

Here's how the dragger looks with it's default geometry in the inactive state:

Use this dragger to allow the end-user of your application to translate along the X-axis and the Y-axis at the same time, ie freely inside a 3D plane. (Use a transformation node in front of the dragger to position it and re-orient it to translate in any plane.)

By holding down a `SHIFT` key, the end-user can temporarily constrain the dragger to a single one of the two axes.

See also:
  SoTranslate1Dragger, SoDragPointDragger

## Public Member Functions

| SoTranslate2Dragger (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFVec3f | translation

## Protected Member Functions

| ~SoTranslate2Dragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)

## Static Protected Member Functions

void | startCB (void *f, SoDragger *d)
void | motionCB (void *f, SoDragger *d)
void | finishCB (void *f, SoDragger *d)
void | metaKeyChangeCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)

## Protected Attributes

SoFieldSensor * | fieldSensor
SbVec3f | worldRestartPt
SbPlaneProjector * | planeProj

## Constructor & Destructor Documentation

SoTranslate2Dragger::SoTranslate2Dragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Node kit structure (new entries versus parent class marked with arrow prefix):

      CLASS SoTranslate2Dragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
               "geomSeparator"
      -->         "translatorSwitch"
      -->            "translator"
      -->            "translatorActive"
      -->         "feedbackSwitch"
      -->            "feedback"
      -->            "feedbackActive"
      -->         "axisFeedbackSwitch"
      -->            "xAxisFeedback"
      -->            "yAxisFeedback"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

      CLASS SoTranslate2Dragger
      PVT   "this",  SoTranslate2Dragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
      PVT   "geomSeparator",  SoSeparator  ---
      PVT   "translatorSwitch",  SoSwitch  ---
            "translator",  SoSeparator  ---
            "translatorActive",  SoSeparator  ---
      PVT   "feedbackSwitch",  SoSwitch  ---
            "feedback",  SoSeparator  ---
            "feedbackActive",  SoSeparator  ---
      PVT   "axisFeedbackSwitch",  SoSwitch  ---
            "xAxisFeedback",  SoSeparator  ---
            "yAxisFeedback",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

SoTranslate2Dragger::~SoTranslate2Dragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoTranslate2Dragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

SbBool SoTranslate2Dragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoTranslate2Dragger::startCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoTranslate2Dragger::motionCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoTranslate2Dragger::finishCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoTranslate2Dragger::metaKeyChangeCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoTranslate2Dragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoTranslate2Dragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoTranslate2Dragger::dragStart | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when dragger is selected (picked) by the user.

void SoTranslate2Dragger::drag | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when user drags the mouse after picking the dragger.

void SoTranslate2Dragger::dragFinish | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when mouse button is released after picking and interacting with the dragger.

## Member Data Documentation

SoSFVec3f SoTranslate2Dragger::translation

| Continuously updated to contain the current translation from the dragger's local origo position. Only the first two components (the X and Y values) can be changed by the end-user. The application programmer applying this dragger in his code should connect the relevant node fields in the scene to this field to make it follow the dragger.

SoFieldSensor * SoTranslate2Dragger::fieldSensor `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

SbVec3f SoTranslate2Dragger::worldRestartPt `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbPlaneProjector * SoTranslate2Dragger::planeProj `[protected]`

| The SbPlaneProjector instance used for projecting from 2D mouse cursor positions to 3D points.

The documentation for this class was generated from the following files:

- SoTranslate2Dragger.h
- SoTranslate2Dragger.cpp